;
;  Designed and written by Daryl Rictor (c)2003-2004
;
;  Define Registers and Port Pins
;
;   Acc = R00, R01 (results of multiply command)
.def  Acc		=	R00			;\ math accumulator
.def  Acch		=	R01			;/ 
.def  svacc		=	R02			;\ Acc reg temp save
.def  svacch	=	R03			;/
.def  fnthl		=	R04			; normal=0x00, inv = 0x80
.def  fntsel	=   R05			; Font Select, 00 = Primary, 08 = Alternate
.def  svz		=	R06			;\ Z reg temp save
.def  svzh  	=   R07			;/
.def  savsr		=	R08			; Status reg temp save
.def  curschr	=   R09			; used by terminal to hold the chr under the cursor

.def  ocrbv		=	R10			; holders for timing values
.def  ocrba		=	R11			; "
.def  linetop	=	R12			; "
.def  line1		= 	R13			; "
.def  line200	=	R14			; "
.def  leftside  =   R15			; "
;-------------------------------------------------
.def  J			=	R16			; scratch 8 bit reg
.def  K			=	R17			; scratch 8 bit reg
.def  hpos		=	R18			; hor cursor pos  0-39
.def  vpos		=	R19			; vert cursor pos 0-24
.def  vline		=	R20			;\ vertical display line counter 0-261
.def  vlineh 	=	R21			;/ hi byte of vline counter
.def  chrln		=  	R22			; display chr line 0 - 199
.def  inpt		=	R23			; HOST input 
.def  cursctl	=   R24			; cursor control
.def  cursclk	=	R25			; the cursor blink timer

;    X pair = R26,27
;    Y pair = R28,29
;    Z pair = R30,31
;
;  X pair used to point to SRAM by refresh routines
;  Y pair used to point to SRAM by HOST processor
;  Z pair used to point to Font data in Program Memory & scrolling

;PORT B pin defs
.set  vd0		=	PB0			; output
.set  vd1		=	PB1			; output
.set  vd2		=	PB2			; output
.set  vd3		=	PB3			; output
.set  vd4		=	PB4			; output
.set  vd5		=	PB5			; output

;PORT C pin defs
.set  syncpin	=	PC0			; output
.set  ldsrpin	=	PC1			; output
.set  vd6		=	PC2			; output
.set  vd7		=	PC3			; output
.set  ackdpin	=	PC4			; output
.set  dflgpin	=	PC5			; input
.set  rstpin	=	PC6			; input

;PORT D defs - video/host data bus
.set  hd0		=	PD0			; input
.set  hd1		=	PD1			; input
.set  hd2		=	PD2			; input
.set  hd3		=	PD3			; input
.set  hd4		=	PD4			; input
.set  hd5		=	PD5			; input
.set  hd6		=	PD6			; input
.set  hd7		=	PD7			; input

;-----------------------------------------