;
;  Define Registers and Port Pins
;
;   Acc = R00, R01 (results of multiply command)
.def  Acc		=	R00			;\ math accumulator
.def  Acch		=	R01			;/ 

.def J			=   R16			; temp data storage
.def K			= 	R17         ; IRQ temp data storage
.def special	=	R18			; hold status flags
.def byte		=   R19			; byte to tx/rx
.def lastbyte	=   R20			; last byte sent (incase of error)
.def parity		=   R21			; parity value rcvd
.def pcnt		=	R22			; parity generator
.def cntr		=  	R23			; bit counter
.def buff		=	R24			; host data buffer pointer

;
; special register bit defs
;
.equ SCRLLOCK	=	0			; 01
.equ NUMLOCK	=	1			; 02
.equ CAPSLOCK	=	2			; 04
.equ CONTROL	=	3			; 08
.equ SHIFT		=	4			; 10
.equ EXT		=	5			; 20

;    Y pair = R28,29
;    Z pair = R30,31
;
;  Y pair used as output buffer to host
;  Z pair used to convert scan codes to ASCII codes

;PORT A pin defs (Host data bus)

;PORT B pin defs
.set  kbclk     =   PB0			; bi directional
.set  kbdat     =   PB1			; bi directional
.set  spkr      =   PB2         ; optional speaker 
.set  datardy   =   PB3			; output to host
.set  sysclki	=   PB4
.set  sysclko	=   PB5
.set  dataack   =   PB6			; input from host (IRQ0)
.set  rstpin	=	PB7			; input
;-----------------------------------------