; /////////////////////////////////////////////////////////////////////////////////
;//                                                                               //
;//  This program and its associated documentation are provided for your personal //
;//  use only and appear here exclusively by permission of the copyright holder.  //
;//  Please contact the copyright holder before re-distributing, re-publishing    //
;//  or disseminating this copyrighted work. This code is not GPL or in the       // 
;//  public domain. Please respect the author's copyright.                        //
;//                                                                               //
;//  No waranty, either expressed or implied, are given.  I assume no liability   //
;//  for its use in any project or device.                                        //
;//                                                                               //
;//  Your use of this program indicates your acceptance of all license terms.     //
;//  This particular version is freeware as long as the copyright messages are    //
;//  left intact.                                                                 //  
;//                                                                               //
; /////////////////////////////////////////////////////////////////////////////////
;
		*= 	$8002			; create exact 32k bin image
		.byte	$20, $09		; date code 

;
; prefill 32k block from $8002-$ffff with 'FF'
;
;      .rept 2047
;         .byte  $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff ;
;      .next 
;      .byte  $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff ;

;
; load 65816 opcodes
;
		.include  macros.inc

; The SPI interface's SCLK divisor is set to 1 for NTSC and 2 for PAL
; The following declaration is used to let the assembler select the
; correct value during the compile.
;
; PAL=0 for NTSC and PAL-1 for PAL systems

PAL = 0

;
; define variables
;
		.include  vars.inc 	

;
; compile the sections of the OS
;
		*=	$D600			; 

		.include  DiskOS.asm		; Disk OS
		.include  diss.asm		; disassembler
		.include  IO.asm		; I/O  routines
		.include  VIA.asm		; init the VIA's			
		.include  xmodem.asm		; xmodem file transfer	
		.include  banner.inc		; splash screen	
		.include  ctext.asm		; Software Text generator 
		.include  SPI.asm		; 65SPI, Keyboard, and RS-232 support

		*=	$F500 	
		.include  crc_tbl.inc		; crc table	(page aligned)

		*=	$F700 	
		.include  font.inc		; font table (page aligned)
 	
		*=	$FF00 
		.include  reset.asm		; $FF00-$FFFF   Reset & Interrupt handler
