;
; bank 7 jump table for code originaing from other banks
;
;

;
; Display routines
;

_cout		#PHB			; save dbr
		#PHK
		#PLB
		jsr	output
		#PLB
		#RTL

_CLS		#PHB			; save dbr
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		jsr	clearsc		; Clear display screen and go to home
		#PLB
		#RTL

_SETX		#PHB			; save dbr
		pha			; save A
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		pla			; restore A 
		jsr	setxpos		; pass in a
		#PLB
		#RTL

_GETX		#PHB			; save dbr
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		lda	curpos
		#PLB
		#RTL

_SETY		#PHB			; save dbr
		pha			; save A
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		pla			; restore A 
		jsr	setypos		; pass in a
		#PLB
		#RTL

_GETY		#PHB			; save dbr
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		lda	curln
		#PLB
		#RTL

_SETC		#PHB			; save dbr
		pha			; save A
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		pla			; restore A 
		sta	hipix		; 1 bit color
		stx	lopix		; 0 bit color
		#PLB
		#RTL

_GETC		#PHB			; save dbr
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		lda	hipix
		ldx	lopix
		#PLB
		#RTL

_CROUT		#PHB			; save dbr
		#PHK
		#PLB
		jsr	print_cr	; CR + LF
		#PLB
		#RTL

_HBOUT		#PHB			; save dbr
		#PHK
		#PLB
		jsr	print1byte
		#PLB
		#RTL

_HWOUT		#PHB			; save dbr
		#PHK
		#PLB
		jsr	print2byte
		#PLB
		#RTL

_CURSOR		#PHB			; save dbr
		pha			; save A
		#LDA_AL	Dispage, SYSBANK
		pha
		#PLB
		pla			; restore A 
		beq	cursor0		; turn cursor off
		lda	#"_"
		sta	cursor
		jsr	showcurs
		#PLB
		#RTL		
cursor0		lda	cursor
		beq	cursor00	; if already off, do nothing
		stz	cursor		; else turn off
		jsr	setchrptr
		lda	#$20
		jsr	showcurs2	; space over cursor chr
cursor00	#PLB
		#RTL		

;
; keyboard routines
;

_cin		#PHB			; save dbr
		#PHK
		#PLB
		jsr	input_chr
		#PLB
		#RTL

_SCAN		#PHB			; save dbr
		#PHK
		#PLB
		jsr	get_status
                #PLB
		#RTL

_INPT		#PHB			; save dbr
		#PHK
		#PLB
		jsr	input
		#PLB
		#RTL

_SCANKB		#PHB			; save dbr
		#PHK
		#PLB
		jsr	scan_input
		#PLB
		#RTL

;
; RS-232 Routines
;

_SERIN		#PHB			; save dbr
		#PHK
		#PLB
		jsr	ser_in
		#PLB
		#RTL

_SEROUT		#PHB			; save dbr
		#PHK
		#PLB
		jsr	ser_out
		#PLB
		#RTL

_SCANSER	#PHB			; save dbr
		#PHK
		#PLB
		jsr	scan_serin
		#PLB
		#RTL

_SETSER		#PHB			; save dbr
		#PHK
		#PLB
		jsr	set_ser
		#PLB
		#RTL

;
; Real Time Clock Routines
;

_GetDT		#PHB			; have ptr pointing to storage
		#PHK
		#PLB
		ldy	#$00
		lda	#$E0			
		jsr	SendIDECmd
GetDT1		jsr	RxIDE
		cmp	#$00
		beq	GetDT2
		#STA_DIIL Ptr		; [d],y
		iny
		bra	GetDT1
GetDT2		#PLB
		#RTL

_PRDT		#PHB			; print date & time
		#PHK
		#PLB
		jsr	ShoDT
		#PLB
		#RTL

_getCalR	#PHB			; send reg ID in a reg 0-6
		#PHK
		#PLB
		pha
		lda	#$E2			
		jsr	SendIDECmd
		lda	#$30
		jsr	SendIDE
		pla
		and	#$07
		ORA	#$30
		jsr	SendIDE
		jsr	RxIDE
		#PLB
		#RTL

_gTicks		#LDA_AL	frmcnt+2, SYSBANK
		tay
		#LDA_AL	frmcnt+1, SYSBANK
		tax
		#LDA_AL	frmcnt, SYSBANK
		#RTL

;
; Disk Routines
;		

_SendIDEC	#PHB			; Send IDE command
		#PHK
		#PLB
		jsr	SendIDECmd
		#PLB
		#RTL

_SendIDE	#PHB			; Send IDE data
		#PHK
		#PLB
		jsr	SendIDE
		#PLB
		#RTL

_RXIDE		#PHB			; Receive IDE data
		#PHK
		#PLB
		jsr	RxIDE
		#PLB
		#RTL

_IDESTAT	#PHB			; Get IDE status
		#PHK
		#PLB
		jsr	IDEStat
		#PLB
		#RTL

_RestDir	#PHB			; restore disk directory to DiskOS's currdir
		#PHK
		#PLB
		jsr	ChaDir0		; 
		#PLB
		#RTL

_LoadF		#PHB			; Do Load File
		#PHK
		#PLB
		jsr	LoadF		; 
		#PLB
		#RTL

_SaveF		#PHB			; Do save File
		#PHK
		#PLB
		jsr	SaveF		; 
		#PLB
		#RTL

