;
; DiskOS Variables
;

SPIPort		= 	$01			; address of SPI port assigned to IDE
CurrPath	=	$0300			; current path
Ptr		=	$E0			; 3 byte memory pointer
temp		= 	$E3			; 1 byte temp holder
Addr		=	$E4			; 3 byte address counter

;
; Diss vars
;

HexDigCnt	=	$EF
ModeJmp		=	$EE
OPCtxtptr	=	$ED
memPtr		=	$EB			; 2bytes

;
; xmodem vars
;

Ptr		=	$E0			; end of file address pointer (2 bytes)
PtrH		=	$E			; = Hexdigits in Monitor 
PtrB		=	$E2			; end block of send, destination block of receive
Addr		=	$E4			; data pointer (two byte variable)
AddrH		=	$E5			; = AddrAddr in Monitor
AddrB		=	$E6			; start block of send
lastblk		=	$E3			; flag for last block
blkno		=	$E7			; block number 
errcnt		=	$E8			; error counter 10 is the limit
bflag		=	$E9			; block flag 
crc		=	$Ea			; CRC lo byte  (two byte variable)
crch		=	$Eb			; CRC hi byte  
retry		=	$Ec			; retry counter 
retry2		=	$Ed			; 2nd counter

;
;IO variables
;

buffer		=	$0200			; keybd input buffer (127 chrs max)
;
; register holding locations
;
PBR		=	$02f0			;  PC Bank
PCH		=	$02f1			;  PC High
PCL		=	$02f2			;  PC low 
DBR		=	$02f3			;  Data bank
B		=	$02f4			;  B accumulator
ACC		=	$02f5			;  Accumulator (A)
XREG		=	$02f6			; hold X reg 16 bit
YREG		=	$02f8			; hold Y reg 16 bit
D		=	$02fa			; D reg 16 bit 
SPTR		=	$02fc			; stack pointer 16 bit
E		=	$02fe			; Emulation mode bit
PREG		=	$02ff			; hold status register (P) 8 bit

;
; End of File
;
