;
;*********************** I/O Locations *******************************
; located on bank 8

;*** 65C22 VIA ***************************

Via1Base	=	$0000
Via1PRB		=	$0000
Via1PRA		=	$0001
Via1DDRB	=	$0002
Via1DDRA	=	$0003
Via1T1CL	=	$0004
Via1T1CH	=	$0005
Via1T1LL	=	$0006
Via1TALH	=	$0007
Via1T2CL	=	$0008
Via1T2CH	=	$0009
Via1SR		=	$000a
Via1ACR		=	$000b
Via1PCR		=	$000c
Via1IFR		=	$000d
Via1IER		=	$000e
Via1PRA1	=	$000f

Via2Base	=	$0010
Via2PRB		=	$0010
Via2PRA		=	$0011
Via2DDRB	=	$0012
Via2DDRA	=	$0013
Via2T1CL	=	$0014
Via2T1CH	=	$0015
Via2T1LL	=	$0016
Via2TALH	=	$0017
Via2T2CL	=	$0018
Via2T2CH	=	$0019
Via2SR		=	$001a
Via2ACR		=	$001b
Via2PCR		=	$001c
Via2IFR		=	$001d
Via2IER		=	$001e
Via2PRA1	=	$001f

;
;
; 65SPI register addresses (using a modified 65SPI for SBC-3)
;

SPIDR		=	$0020			; SPI data port
SPISR		=	$0021			; SPI status
SPICR		=	$0021			; SPI control
SPIDIV		=	$0022			; SPI SCLK divisor (6 bits)
SPISSR		=	$0023			; SPI Slave Select register
SPIISR		=	$0024			; SPI Interrupt status register

;
; XC95108 Video Data Register
;

VDR		=	$30			; Video Data Register

;
;********************** SYSTEM Wide ******************************
;

SYSBANK		=	$07			; bank where system will load
IOBANK		=	$08			; bank where IO devices are located
frmcnt		=	$FD			; three byte located in SYSBANK

;
;********************** DiskOS Variables *************************
;

SPIIDE		= 	$01			; address of SPI port assigned to IDE
CurrPath	=	$0300			; current path
Ptr		=	$E0			; 3 byte memory pointer
temp		= 	$E3			; 1 byte temp holder
Addr		=	$E4			; 3 byte address counter

;
;********************** CTEXT.ASM *********************************
;

;constants

;bank 7
dispage		=	$FFFF			; display block pointer 0-7, 1 is default

;bank 1 (retained)
curln		=	$FDF0			; 0-24
curpos		=	$FDF1			; 0-39
lopix		=	$FDF2			; color of 0 bit pixels (actual address is in display page, $01 by default) 
hipix		=	$FDF3			; color of 1 bit pixels (actual address is in display page)
cursor		=	$FDF4			; ascii code for cursor, 0=no cursor 

;zero page temp
chrptr		=	$F2			; 2 bytes  pointer to character storage area $xFA00-$xFDE7
chrptr_H	=	$F3			; 2 bytes  pointer to character storage area $xFA00-$xFDE7
vidptr		=	$F4			; 2 bytes  pointer to display area $x0000-$xF9FF
vidptr_H	=	$F5			; 2 bytes  pointer to display area $x0000-$xF9FF
tmp1		=	$F9			; 2 bytes
tmp1_H		=	$FA			; 2 bytes
tmp2		=	$FB			; 3 bytes
tmp2_H		=	$FC			; 3 bytes
tmp2_B		=	$FD			; 3 bytes

;bank 1 temp
cnt1		=	$FDFD
cnt2		=	$FDFE
cnt3		=	$FDFF
;

;
; Diss vars
;

HexDigCnt	=	$EF
ModeJmp		=	$EE
OPCtxtptr	=	$ED
memPtr		=	$EB			; 2bytes

;
;***************************** xmodem vars
;

Ptr		=	$E0			; end of file address pointer (2 bytes)
PtrH		=	$E1			; = Hexdigits in Monitor 
PtrB		=	$E2			; end block of send, destination block of receive
Addr		=	$E4			; data pointer (two byte variable)
AddrH		=	$E5			; = AddrAddr in Monitor
AddrB		=	$E6			; start block of send
lastblk		=	$E3			; flag for last block
blkno		=	$E7			; block number 
errcnt		=	$E8			; error counter 10 is the limit
bflag		=	$E9			; block flag 
crc		=	$Ea			; CRC lo byte  (two byte variable)
crch		=	$Eb			; CRC hi byte  
retry		=	$Ec			; retry counter 
retry2		=	$Ed			; 2nd counter
;
; non-zero page variables and buffers
;
Rbuff		=	$0200			; temp 132 byte receive buffer 
						;(place anywhere, page aligned)
;
;****************************** IO variables
;

buffer		=	$0200			; keybd input buffer (127 chrs max)
;
; register holding locations
;
PBR		=	$02f0			;  PC Bank
PCH		=	$02f1			;  PC High
PCL		=	$02f2			;  PC low 
DBR		=	$02f3			;  Data bank
B		=	$02f4			;  B accumulator
ACC		=	$02f5			;  Accumulator (A)
XREG		=	$02f6			; hold X reg 16 bit
YREG		=	$02f8			; hold Y reg 16 bit
D		=	$02fa			; D reg 16 bit 
SPTR		=	$02fc			; stack pointer 16 bit
E		=	$02fe			; Emulation mode bit
PREG		=	$02ff			; hold status register (P) 8 bit

;
; End of File
;