;******** LOAD & SAVE PATCH FOR ENHANCED BASIC ON SBC-3
; Daryl Rictor, Feb 2009
;

.include dos.lbl			; get DiskOS pointers
;input		; sbc scanned input
;output		; text output
;DiskOS		; diskos entry
;SaveF		; save program file from BASIC
;LoadF		; load program file from BASIC

;ibuffs+1 ($420) is the contains the name, start addr, end address

psave		ldx	#$00
		lda	ibuffs+1
		stz	ibuffs+1	; this fixes syntax error in ehbasic
		bne	psave15
		rts
psave1		lda	ibuffs+1,x
		stz	ibuffs+1,x	; this fixes syntax error in ehbasic
		beq	psave3
psave15		cmp	#$b9
		bne	psave2
		lda	#"/"
psave2		sta	$202,x
		inx
		cpx	#$46
		bne	psave1
		rts			; entry too long, abort
psave3		lda	#","
		sta	$202,x
		inx
		phx
		jsr	pscan		; Find end of program
		plx
		lda	smemh
		jsr	ToHex
		lda	smeml
		jsr	ToHex
		lda	#","
		sta	$202,x
		inx
		lda	itemph
		jsr	ToHex
		lda	itempl
		jsr	ToHex
		lda	#$00
		sta	$202,x
		jsr	SaveF		; save file to IDE (in DiskOS)
		rts

pload		ldx	#$00
		lda	ibuffs+1
		stz	ibuffs+1	; this fixes syntax error in ehbasic
		bne	pload15
		rts
pload1		lda	ibuffs+1,x
		beq	pload3
pload15		cmp	#$b9
		bne	pload2
		lda	#"/"
pload2		sta	$202,x
		inx
		cpx	#$47
		bne	pload1
		rts			; entry too long, abort
pload3		lda	#$00
		sta	$202,x
		jsr	Loadf		; load file from IDE (in DiskOS)
		jsr	pscan
		lda	itempl
		sta	svarl
		sta	sarryl
		sta	earryl
		lda	itemph
		sta	svarh
		sta	sarryh
		sta	earryh
		JMP   LAB_1319		

pscan
		lda	smeml
	      	sta	itempl
      		lda	smemh
	      	sta	itemph
pscan1		ldy   #$00
		lda   (itempl),y
		bne   pscan2
		iny   
		lda   (itempl),y
		bne   pscan2
		clc
		lda   #$02
		adc   itempl
		sta	itempl
		lda	#$00
		adc	itemph
		sta	itemph
		rts
pscan2		ldy   #$00
		lda	(itempl),y
		tax
		iny
		lda	(itempl),y
		sta	itemph
		stx	itempl
		bra	pscan1

SysJMP		JSR	Main_Loop	; in DiskOS
		rts

ToHex		PHA                     ;  prints AA hex digits
		LSR                     ;  MOVE UPPER NIBBLE TO LOWER
		LSR                     ;
		LSR                     ;
		LSR                     ;
		JSR   SaveDig           ;
		PLA                     ;
SaveDig		AND   #$0F              ;
		CMP   #$0A              ;
		BCC   SaveDig1          ;
		ADC   #$66              ;
SaveDig1	EOR   #$30              ;
		sta   $202,x            ;
		inx
		rts