; /////////////////////////////////////////////////////////////////////////////////
;//                                                                               //
;//  This program and its associated documentation are provided for your personal //
;//  use only and appear here exclusively by permission of the copyright holder.  //
;//  Please contact the copyright holder before re-distributing, re-publishing    //
;//  or disseminating this copyrighted work. This code is not GPL or in the       // 
;//  public domain. Please respect the author's copyright.                        //
;//                                                                               //
;//  No waranty, either expressed or implied, are given.  I assume no liability   //
;//  for its use in any project or device.                                        //
;//                                                                               //
;//  Your use of this program indicates your acceptance of all license terms.     //
;//  This particular version is freeware as long as the copyright messages are    //
;//  left intact.                                                                 //  
;//                                                                               //
; /////////////////////////////////////////////////////////////////////////////////
;
      *= $8002			; create exact 32k bin image

;
; prefill 32k block from $8002-$ffff with 'FF'
;
      .rept 2047
         .byte  $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff ;
      .next 
      .byte  $ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff ;

;
; load 65816 opcodes
;
      .include macros.inc

;
; The SPI interface's SCLK divisor is set to 1 for NTSC and 2 for PAL
; The following declaration is used to let the assembler select the
; correct value during the compile.
;
; PAL=0 for NTSC and PAL-1 for PAL systems

PAL = 0

;
; compile the sections of the OS
;
      .include logo.inc            ; embedded sbc-3 logo into unused ROM space	
      .include banner.inc          ; Boot Screen
      *=$E200                      ; Use $E200-$FFFF (8k - other 24k open for user apps)
      .include crc_tbl.inc         ; XMODEM CRC tables (page aligned)
      .include font.inc            ; font table (page aligned)
      .include xmodem.inc          ; Xmodem file transfer routines
      .include ctext.asm           ; Software Text generator (NEW COLOR VERSION)
      .include VIA1.asm		   ; VIA1 initialization
      .include VIA2.asm		   ; VIA2 initialization
      .include SPI.asm	           ; 65SPI, Keyboard, and RS-232 support
      .include sbcos.asm           ; Monitor and I/O  

      *= $FF00
      .include reset.asm         ; $FF00-$FFFF   Reset & Interrupt handler

