; /////////////////////////////////////////////////////////////////////////////////
;//                                                                               //
;//  This program and its associated documentation are provided for your personal //
;//  use only and appear here exclusively by permission of the copyright holder.  //
;//  Please contact the copyright holder before re-distributing, re-publishing    //
;//  or disseminating this copyrighted work. This code is not GPL or in the       // 
;//  public domain. Please respect the author's copyright.                        //
;//                                                                               //
;//  No waranty, either expressed or implied, are given.  I assume no liability   //
;//  for its use in any project or device.                                        //
;//                                                                               //
;//  Your use of this program indicates your acceptance of all license terms.     //
;//  This particular version is freeware as long as the copyright messages are    //
;//  left intact.                                                                 //  
;//                                                                               //
; /////////////////////////////////////////////////////////////////////////////////
;
;*******************************************************************************
;
;  SBC-3 VIA1 Initialization                    (c) Daryl Rictor Nov 6, 2008
;
;*******************************************************************************
;
;
;*** I/O Locations *******************************
; define the i/o address of the Via1 chip
;*** 6522 CIA ************************
Via1Base       =     $0000
Via1PRB        =     $0000
Via1PRA        =     $0001
Via1DDRB       =     $0002
Via1DDRA       =     $0003
Via1T1CL       =     $0004
Via1T1CH       =     $0005
Via1T1LL       =     $0006
Via1TALH       =     $0007
Via1T2CL       =     $0008
Via1T2CH       =     $0009
Via1SR         =     $000a
Via1ACR        =     $000b
Via1PCR        =     $000c
Via1IFR        =     $000d
Via1IER        =     $000e
Via1PRA1       =     $000f
;
;***********************************************************************
; 6522 VIA I/O Support Routines
;
Via1_init      ldx   #$00              ; get data from table
Via1init1      lda   Via1idata,x       ; init all 16 regs from 00 to 0F
               sta   Via1Base,x        ; 
               inx                     ; 
               cpx   #$0f              ; 
               bne   Via1init1         ;       
               rts                     ; done
;
Via1idata      .byte $00               ; prb  '00000000'
               .byte $00               ; pra  "00000000'
               .byte $00               ; ddrb 'iiiiiiii'
               .byte $00               ; ddra 'iiiiiiii'
               .byte $00               ; tacl  
               .byte $00               ; tach  
               .byte $00               ; tall  
               .byte $00               ; talh  
               .byte $00               ; t2cl
               .byte $00               ; t2ch
               .byte $00               ; sr
               .byte $00               ; acr
               .byte $00               ; pcr
               .byte $7f               ; ifr
               .byte $7f               ; ier
; 
;
;
;end of file
