; /////////////////////////////////////////////////////////////////////////////////
;//                                                                               //
;//  This program and its associated documentation are provided for your personal //
;//  use only and appear here exclusively by permission of the copyright holder.  //
;//  Please contact the copyright holder before re-distributing, re-publishing    //
;//  or disseminating this copyrighted work. This code is not GPL or in the       // 
;//  public domain. Please respect the author's copyright.                        //
;//                                                                               //
;//  No waranty, either expressed or implied, are given.  I assume no liability   //
;//  for its use in any project or device.                                        //
;//                                                                               //
;//  Your use of this program indicates your acceptance of all license terms.     //
;//  This particular version is freeware as long as the copyright messages are    //
;//  left intact.                                                                 //  
;//                                                                               //
; /////////////////////////////////////////////////////////////////////////////////
;
;*******************************************************************************
;
;  SBC-3 VIA2 Initialization                    (c) Daryl Rictor Nov 6, 2008
;
;*******************************************************************************
;
; ----------------- assembly instructions ---------------------------- 
;
; this is a subroutine library only
; it must be included in an executable source file
;
;
;*** I/O Locations *******************************
; define the i/o address of the Via2 chip
;*** 6522 CIA ************************
Via2Base       =     $0010
Via2PRB        =     $0010
Via2PRA        =     $0011
Via2DDRB       =     $0012
Via2DDRA       =     $0013
Via2T1CL       =     $0014
Via2T1CH       =     $0015
Via2T1LL       =     $0016
Via2TALH       =     $0017
Via2T2CL       =     $0018
Via2T2CH       =     $0019
Via2SR         =     $001a
Via2ACR        =     $001b
Via2PCR        =     $001c
Via2IFR        =     $001d
Via2IER        =     $001e
Via2PRA1       =     $001f
;
;***********************************************************************
; 6522 VIA I/O Support Routines
;
Via2_init      ldx   #$00              ; get data from table
Via2init1      lda   Via2idata,x       ; init all 16 regs from 00 to 0F
               sta   Via2Base,x        ; 
               inx                     ; 
               cpx   #$0f              ; 
               bne   Via2init1         ;       
               rts                     ; done
;
Via2idata      .byte $00               ; prb  '00000000'
               .byte $00               ; pra  "00000000'
               .byte $00               ; ddrb 'iiiiiiii'
               .byte $00               ; ddra 'iiiiiiii'
               .byte $00               ; tacl  
               .byte $00               ; tach  
               .byte $00               ; tall  
               .byte $00               ; talh  
               .byte $00               ; t2cl
               .byte $00               ; t2ch
               .byte $00               ; sr
               .byte $00               ; acr
               .byte $00               ; pcr
               .byte $7f               ; ifr
               .byte $7f               ; ier
; 
;
;
;end of file
