;
; design goal - record remote control pulses at a period of 22uS
; store up to 64 - 4 byte cycles for coding and sending
; 
;
; 0 timing deviations achieved
;
       *=    $5000           ;
buffer  =    $6000
ptr     =    $00
      

        lda  #$00            ;
        sta  ptr             ; init pointer
        lda  $7f03           ;
        and  #$DF            ;
        sta  $7f03           ; set bit 5 for input

wait    lda  $7f01           ;  
        and  #$20            ;
        bne  wait            ; wait for led to come on

loop1   ldx  #$00            ; 2   init counters for on time
        ldy  #$00            ; 2   
        bra  loop1c          ; 3

loop1a  nop                  ; 2
        nop                  ; 2
loop1b  lda  ptr             ; 3
loop1c  nop                  ; 2
        lda  $7f01           ; 4   read recvr for led on
        and  #$20            ; 2
        bne  loop1d          ; 2   by leaving before inx, we leave table reduced by 1
        inx                  ; 2   count cycles                          as desired  
        bne  loop1a          ; 3  2    
        iny                  ;    2
        bra  loop1b          ;    3

loop1d  tya                  ; 2    save on time info in table 
        ldy  ptr             ; 3   
        sta  buffer,y        ; 5 
        txa                  ; 2
        iny                  ; 2
        sta  buffer,y        ; 5
        iny                  ; 2
        sty  ptr             ; 3
        beq  done            ; 2  even at 22


loop2   ldx  #$02            ; 2   init counters for off time
        ldy  #$00            ; 2   +1 for loop1d code
        bra  loop2c          ; 3   +1 because routine exits before inx

loop2a  nop                  ; 2
        nop                  ; 2
loop2b  lda  ptr             ; 3
loop2c  nop                  ; 2
        lda  $7f01           ; 4   read recvr for led off
        and  #$20            ; 2
        beq  loop2d          ; 2   by leaving before inx, we leave table reduced by 1
        inx                  ; 2   count cycles                          as needed
        bne  loop2a          ; 3  2    
        iny                  ;    2
        bne  loop2b          ;    3
        bra  done            ; if txmtr goes off before we have all 64 entries,
                             ; the x & y will overflow and 0 0 will be stored!
                             ;       
loop2d  tya                  ; 2         led went on (or timed out) (18)
        ldy  ptr             ; 3         save off timing
        sta  buffer,y        ; 5
        txa                  ; 2         33uS-4uS = 29 uS
        iny                  ; 2
        sta  buffer,y        ; 5         29uS - 22uS = 7uS
        iny                  ; 2         so we branch to loop1c to comp.
        sty  ptr             ; 3
        beq  done            ; 2
        ldx  #$01            ; 2
        ldy  #$00            ; 2 
        bra  loop1c          ; 3  (51)
done    rts                  ;
        