; /////////////////////////////////////////////////////////////////////////////////
;//                                                                               //
;//  This program and its associated documentation are provided for your personal //
;//  use only and appear here exclusively by permission of the copyright holder.  //
;//  Please contact the copyright holder before re-distributing, re-publishing    //
;//  or disseminating this copyrighted work. This code is not GPL or in the       // 
;//  public domain. Please respect the author's copyright.                        //
;//                                                                               //
;//  No waranty, either expressed or implied, are given.  I assume no liability   //
;//  for its use in any project or device.                                        //
;//                                                                               //
;//  Your use of this program indicates your acceptance of all license terms.     //
;//  This particular version is freeware as long as the copyright messages are    //
;//  left intact.                                                                 //  
;//                                                                               //
; /////////////////////////////////////////////////////////////////////////////////
;
;
; SPI PC keyboard and RS-232 I/O register definitions 
;
;
; R0, R1   Acc
; R2  KBEAT
; R3  KBEXTRLS
; R4  KB status
; R5  RS232 Rcv status
; R6   
; R7   
; R8   RS232 Rcv buff in 
; R9   ..
; R10  RS232 Rcv buff out 
; R11  ..
; R12  KB buff in
; R13  ..
; R14  KB buff out
; R15  ..
; R16  i
; R17  j 
; R18  - special
; R19  - byte
; R20  - lastbyte
; R21  - parity
; R22  - pcnt
; R23  - cntr
; R24  
; R25  
; R26 
; R27  SERP
; R28  SMODE - SPI Mode - 0 command, 1 ser TX byte, 2 ser parms, 3 KB cmd
; R29  SPIST - SPI system Status 
; R30 \ Z - used to convert scan codes to ASCII codes
; R31 / 

.def KBEAT              = R2                    ; used to eat unwanted scan codes for pause/break
.def KBEXTRLS           = R3                    ; flags ext keycode release mode
.def KBST 		= R4			; KB Rx buffer counter
.def RBST 		= R5			; RS232 Rx buffer counter
.def RBIN       	= R8          		; R8,R9
.def RBOUT      	= R10         		; R10,R11
.def KBIN       	= R12         		; R12,R13
.def KBOUT      	= R14         		; R14, R15
.def i          	= R16         		; temp 
.def j          	= R17         		; temp
.def special		= R18			; holds status flags
.def byte		= R19			; byte to tx/rx
.def lastbyte		= R20			; last byte sent (incase of error)
.def parity		= R21			; parity value rcvd
.def pcnt		= R22			; parity generator
.def cntr		= R23			; bit counter
.def SMODE      	= R24          		; SPI mode
.def SPIST      	= R25          		; status reported to SPI

.undef XL
.undef XH
;.undef YL
;.undef YH
.def KBMODE 		= R26			; KB mode - $00 = ASCII (default), $80 = SCANCODE raw
.def SERP       	= R27          		; serial port parameters
;
; special register bit defs
;
.equ SCRLLOCK		= 0			; 01
.equ NUMLOCK		= 1			; 02
.equ CAPSLOCK		= 2			; 04
.equ CONTROL		= 3			; 08
.equ SHIFT		= 4			; 10
.equ EXT		= 5			; 20
.equ EXTSH		= 6			; 40  
.equ RLSE		= 7			; 80  key release code
;
.DSEG

.ORG $0100
USARTRXBUFFER:			.byte 256

.org $0200
KBRXBUFFER:			.byte 256

.CSEG
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
