;
; Ullrich von Bassewitz, 16.11.2002
;
; int __fastcall__ close (int fd);
;
;
; Modified for SBC-3 by Daryl Rictor
;

	.export		_close

	.import		__oserror
	.importzp	tmp2

	.include	"errno.inc"
	.include	"filedes.inc"
	.include	"sbc3.inc"

;--------------------------------------------------------------------------
; _close

.proc	_close

; Check if we have a valid handle

	cpx	#$00
	bne	invalidfd
	cmp	#MAX_FDS	; Is it valid?
	bcs	invalidfd	; Jump if no
	sta	tmp2		; Save the handle

; Check if the file is actually open

	tax
	lda	fdtab,x		; Get flags for this handle
	beq	notopen

; Valid handle, close it. The close call is always error free, at least as far
; as the kernal is involved

	lda     #0		; file closed
	sta     fdtab,x
	lda     tmp2            ; Get the handle
	and	#$0F		; mask to lower 16 handles
	pha			; save handle
 	lda	#$CE		; CLose cmd
 	jsl	_sendidec
	pla
 	jsl	_sendide	; send handle
ftst:	jsl	_idestat
	cmp	#$00
	bpl	ftst		; wait for ready
	and	#$1F		; mask lower 5 bits	
	bne	error		; send system error

; Successful

	tax			; Return zero in a/x
	rts

; Error entry, file descriptor is invalid

invalidfd:
	lda	#EINVAL
	sta	__errno
	lda	#0
	sta	__errno+1
	bra	errout

; Error entry, file is not open

notopen: lda	#$08		; file not opened
		
; Error entry, status not ok

error:	sta	__oserror
errout:	lda	#$FF
	tax			; Return -1
	rts

.endproc
