;
; Ullrich von Bassewitz, 17.06.1998
;
; Startup code for cc65
;
; This must be the *first* file on the linker command line
;
;
; Modified for SBC-3 by Daryl Rictor
;
	.export		_exit
	.export		__STARTUP__ : absolute = 1	; Mark as startup
	.import		__RAM_START__
	.import		initlib, donelib
	.import		callmain                      ;, callirq
	.import		zerobss                       ;, push0
;	.import		_main

	.include	"zeropage.inc"
	.include	"sbc3.inc"

;
; SBC-3 file format includes a 3 byte load address at the beginning of the file
; The EXEHDR segment places these three bytes at the beginning of the output file
;

.segment	"EXEHDR"

        .word           __RAM_START__			; Start address
        .byte		$00					; bank 0

.segment   "STARTUP"

; ------------------------------------------------------------------------
; Actual code

; Clear the BSS data

	jsr	zerobss

; setup the stack

	lda	#<TOPMEM
	sta	sp
	lda	#>TOPMEM
	sta	sp+1			; Set argument stack ptr

; save SBC-3 display properties
	lda	$01fdf2
	sta	locol
	lda	$01fdf3
	sta	hicol
	lda	$01fdf4
	sta	curs

; Call module contructors

	jsr	initlib

; Push arguments and call main

	jsr	callmain

; Call module destructors. This is also the _exit entry.

_exit:	jsr	donelib

; restore SBC-3 display properties
	lda	locol
	sta	$01fdf2
	lda	hicol
	sta	$01fdf3
	lda	curs
	sta	$01fdf4
	jml	_osreturn		; SBC-3 DiskOS re-entry point

.bss

hicol:	.res	1
locol:	.res	1
curs:		.res	1

