;
; Daryl Rictor
;
; long fsize (int handle);	
;
; created for SBC-3 by Daryl Rictor
;

	.export		_fsize

	.import		__oserror
	.importzp	sp, sreg, tmp2

	.include	"errno.inc"
	.include	"fcntl.inc"
	.include	"filedes.inc"
	.include	"sbc3.inc"

;--------------------------------------------------------------------------
; long _fsize(int)

.proc	_fsize

; Check if we have a valid handle

	cpx	#$00
	bne	invalidfd
	cmp	#MAX_FDS	; Is it valid?
	bcs	invalidfd	; Jump if no
	sta	tmp2		; Save the handle

; Check if the file is actually open

	tax
	lda	fdtab,x		; Get flags for this handle
	beq	notopen

; Valid handle

	lda	#$D0		; File Len cmd
 	jsl	_sendidec
	lda	tmp2
 	jsl	_sendide	; send handle
	nop
	nop
	nop
	jsl	_rxide
	pha
	nop
	nop
	jsl	_rxide
	pha
	nop
	nop
	jsl	_rxide
	pha
	nop
	nop
	jsl	_rxide
	pha
	nop

:	jsl	_idestat			; check ide status to be sure data is valid
	cmp	#$00
	bpl	:-

	and	#$1F				; mask error
	bne	error

	pla					; pop long length from stack
	sta	sreg+1
	pla
	sta	sreg
	plx
	pla
	rts					

; Error entry, disk i/o, pop stack then do sys error
error:
	plx
	plx
	plx
	plx
	bra	error1

; Error entry, file descriptor is invalid

invalidfd:
	lda	#EINVAL
	sta	__errno
	lda	#0
	sta	__errno+1
	bra	errout

; Error entry, file is not open

notopen: lda	#$08		; file not opened
		
; Error entry, status not ok

error1:	sta	__oserror
errout:	lda	#$FF
	tax			; Return -1
	rts

.endproc
