;
; created by Daryl Rictor for SBC-3 (c) 2010
;

;
; long = lseek(f->f_fd, offset, SEEK_SET)
;

;
; two paths - one has offset = 0 with SEEK_SET = SEEK_CUR
; this is getpos
;
; any other will be a setpos
;
	.import	popax
	.import	__oserror
	.importzp	sreg

	.export	_lseek

	.include 	"sbc3.inc"    
	.include	"stdio.inc"
	.include	"errno.inc"

.code

.proc	_lseek
	sta	sreg				; seek type
	jsr	popax				; low offset word
	sta	Ptr				
	stx	Ptr+1
	jsr	popax				;  high offset word
	sta	Ptr+2
	stx	temp
	jsr	popax				;  handle
	and	#$0F				; mask handle to 0-F
	sta	Addr				; handle

	lda	sreg				; SEEK_CUR
	bne	seek				; if not SEEK_CUR, do setpointer
	lda	Ptr
	ora	Ptr+1
	ora	Ptr+2
	ora	temp
	bne	seek				; is offset = 0? (no)
read:
	lda	#$CD				; get file ptr
	jsl	_sendidec
	lda	Addr				; handle
	jsl	_sendide
	nop
	jsl	_rxide
	sta	Ptr				; load 32 bit value into ptr1,ptr2
	jsl	_rxide
	sta	Ptr+1
	jsl	_rxide
	sta	Ptr+2
	jsl	_rxide
	sta	temp

:	jsl	_idestat			; check ide status to be sure data is valid
	cmp	#$00
	bpl	:-

	and	#$1F				; mask error
	bne	error1

	lda	Ptr+2				; push upper word to C stack
	sta	sreg
	ldx	temp
	stx	sreg+1
	lda	Ptr				; load lower word in to a,x
	ldx	Ptr+1
	rts					

error0:
	lda	#EINVAL			; Invalid Argument error code
	sta	__errno
	lda	#0
	sta	__errno+1
	bra	errout
error1:
	sta	__oserror
errout:
	lda	#$ff
	tax
	sta	sreg
	sta	sreg+1
	rts
	
seek:						; offset > 0
	lda	#$CC				; Set file ptr
	jsl	_sendidec
	lda	Addr				; handle
	jsl	_sendide
	lda	sreg				; seek type
	jsl	_sendide
	lda	Ptr
	jsl	_sendide
	lda	Ptr+1
	jsl	_sendide
	lda	Ptr+2
	jsl	_sendide
	lda	temp
	jsl	_sendide
:	jsl	_idestat
	cmp	#$00
	bpl	:-
	and	#$1F				; mask errors
	bne	error1
	jmp	read
	
.endproc

; seek set in a,x
; popax has offset low word
; popax offset high word 
; popax file ptr

; return low word of pointer in ax
; return high word of pointer in sreg,sreg+1

; seek type stored in sreg
; offset in Ptr,Ptr+1,Ptr+2,temp
; handle in Addr

;#define SEEK_CUR	0
;#define SEEK_END	1
;#define SEEK_SET	2 
