echo off
rem
rem  This batch file will compile the SBC-3 library files and place
rem  them in proper folders.  It will then cleanup all non-source files.
rem
rem  Use this at your own risk.  I assume no liability for its use.
rem
rem  (c) Daryl Rictor 2010
rem
@echo off
echo SBC3
cd SBC3
for %%i in (*.s) do ca65 -l %%i
copy crt0.o ..\sbc3.o >nul

echo common
cd ..\common
for %%i in (*.c) do cc65 -Osir -g -I..\..\include %%i
for %%i in (*.s) do ca65 %%i

echo conio
cd ..\conio
for %%i in (*.s) do ca65 %%i

echo dbg
cd ..\dbg
for %%i in (*.s) do ca65 %%i

echo runtime
cd ..\runtime
for %%i in (*.s) do ca65 %%i

echo tgi
cd ..\tgi
..\..\bin\cc65 tgi_load.c
..\..\bin\cc65 tgi_load_driver.c
for %%i in (*.s) do ca65 %%i

echo serial
cd ..\serial
for %%i in (*.s) do ca65 %%i

echo Build library
cd ..
if exist sbc3.lib del sbc3.lib >nul:

ar65 a sbc3.lib common\*.o
ar65 a sbc3.lib runtime\*.o
ar65 a sbc3.lib conio\*.o
ar65 a sbc3.lib dbg\*.o
ar65 a sbc3.lib tgi\*.o
ar65 a sbc3.lib serial\*.o
ar65 a sbc3.lib sbc3\*.o

echo Move library files
if not exist %CC65%\lib\nul mkdir %CC65%\lib
copy sbc3.lib ..\lib >nul
copy sbc3.o   ..\lib >nul

echo Cleanup
rem del sbc3\*.lst
del sbc3\*.o
del common\*.o
del conio\*.o
del dbg\*.o
del runtime\*.o
del tgi\*.o
del serial\*.o
del sbc3.lib
del sbc3.o

pause
