;
; Stefan Haubenthal, 2003-12-24
; Ullrich von Bassewitz, 18.07.2002
;
; Defines the platform specific error list.
;
; The table is built as a list of entries
;
;       .byte   entrylen
;       .byte   errorcode
;       .asciiz errormsg
;
; and terminated by an entry with length zero that is returned if the
; error code could not be found.
;
;
; Modified for SBC-3 by Daryl Rictor
;
	.export		__sys_oserrlist

;----------------------------------------------------------------------------
; Macros used to generate the list (may get moved to an include file?)

; Regular entry
.macro	sys_oserr_entry		code, msg
	.local	Start, End
Start:	.byte	End - Start
	.byte	code
	.asciiz msg
End:
.endmacro

; Sentinel entry
.macro	sys_oserr_sentinel      msg
	.byte	0			; Length is always zero
	.byte	0			; Code is unused
	.asciiz	msg
.endmacro

;----------------------------------------------------------------------------
; The error message table

.rodata

__sys_oserrlist:

	sys_oserr_entry		$01, "ATA init error"
	sys_oserr_entry		$02, "Missing file name"
	sys_oserr_entry		$03, "Format error"
	sys_oserr_entry		$04, "File not found"
	sys_oserr_entry		$05, "Read-only file"
	sys_oserr_entry		$06, "Invalid file type/open error"
	sys_oserr_entry		$07, "Unable to erase all files"
	sys_oserr_entry		$08, "File not open"
	sys_oserr_entry		$09, "File already open in another handle"
	sys_oserr_entry		$0A, "File protected"
	sys_oserr_entry		$0B, "Disk full"
	sys_oserr_entry		$0C, "Root directory full"
	sys_oserr_entry		$0D, "Invalid command"
	sys_oserr_entry		$0E, "Handle in use"
	sys_oserr_entry		$0F, "Read past EOF"
	sys_oserr_entry		$10, "File too large > 2^32"
	sys_oserr_entry		$11, "Cluster size too big"

	sys_oserr_sentinel	"Unknown error"
