;
; Ullrich von Bassewitz, 17.05.2000
;
; int __fastcall__ _osmaperrno (unsigned char oserror);
;
;
; Modified for SBC-3 by Daryl Rictor
;
	.export		__osmaperrno

	.include	"errno.inc"

__osmaperrno:
	ldx	#ErrTabSize
:	cmp	ErrTab-2,x	; Search for the error code
	beq	:+		; Jump if found
	dex
	dex
	bne	:-		; Next entry

	; Code not found, return EUNKNOWN
	lda	#<EUNKNOWN
	ldx	#>EUNKNOWN
	rts

	; Found the code
:	lda	ErrTab-1,x
	ldx	#$00		; High byte always zero
	rts

	.rodata

ErrTab:
	.byte		$01, EIO	; ATA init error 
	.byte		$02, EINVAL	; Missing file name 
	.byte		$03, EIO	; Format error 
	.byte		$04, ENOENT	; File not found 
	.byte		$05, EACCES	; Read-only file 
	.byte		$06, ENOENT	; Invalid file type/open error 
	.byte		$07, EAGAIN	; Unable to erase all files 
	.byte		$08, ENOENT	; File not open
	.byte		$09, EMFILE	; File already open in another handle 
	.byte		$0A, EACCES	; File protected 
	.byte		$0B, ENOSPC	; Disk full 
	.byte		$0C, ENOSPC	; Root directory full 
	.byte		$0D, ENOSYS	; Invalid command 
	.byte		$0E, EMFILE	; Handle in use 
	.byte		$0F, ESPIPE	; Read past EOF 
	.byte		$10, ERANGE	; File too large > 2^32 
	.byte		$11, EIO	; Cluster size too big 

ErrTabSize = (* - ErrTab)

