/* sbc3.h */
/* Modified for SBC-3 by Daryl Rictor */

#ifndef SBC3_H
#define SBC3_H

/* Zero-page locations */
#define Ptr (*(unsigned char*)0xe0)
#define temp (*(unsigned char*)0xe3)
#define Addr (*(unsigned char*)0xe4)

#include <_6522.h>
#define VIA1    (*(struct __6522*)0x080000)
#define VIA2    (*(struct __6522*)0x080010)

/* Color codes */
#define COLOR_WHITE     255
#define COLOR_BLACK     0
#define COLOR_BLUE      208
#define COLOR_YELLOW    127
#define COLOR_RED       79
#define COLOR_GREEN     57
#define COLOR_ORANGE    111
#define COLOR_VIOLET    229


#define CH_ULCORNER     '+'
#define CH_URCORNER     '+'
#define CH_LLCORNER     '+'
#define CH_LRCORNER     '+'
#define CH_TTEE         '+'
#define CH_BTEE         '+'
#define CH_LTEE         '+'
#define CH_RTEE         '+'
#define CH_CROSS        '+'

/* SBC-3 specific functions */
unsigned char cputtm (void);
void sbc3_tgi (void);
unsigned char __fastcall__ peek (long);
void poke (long,unsigned char);
void sbc3_ser(void);
unsigned long systime(void);
long __fastcall__ fsize(int);

/* Useful macros */
#define hibyte(x) (__AX__=(x),asm("\ttxa\n\tldx\t#$00"),__AX__)
//#define hibyte(x) (x >> 8)
#define lobyte(x) (__AX__=(x),asm("\tldx\t#$00"),__AX__)
//#define lobyte(x) (x & 0xFF)
#define hiword(x) (x >> 16)
#define loword(x) (x & 0xFFFF)

#endif
