;
; Stefan Haubenthal, 27.7.2009
;
;
; Modified for SBC-3 by Daryl Rictor
;

; time_t _systime (void);
; /* Similar to time(), but:
;  *   - Is not ISO C
;  *   - Does not take the additional pointer
;  *   - Does not set errno when returning -1
;  */


	.include	"time.inc"
	.include	"SBC3.inc"


;----------------------------------------------------------------------------
.code

.proc	__systime

	lda	#02
	jsl	_getcalr
	jsr	BCD2dec
	sta	TM + tm::tm_hour

	lda	#01
	jsl	_getcalr
	jsr	BCD2dec
	sta	TM + tm::tm_min

	lda	#00
	jsl	_getcalr
	jsr	BCD2dec
	sta	TM + tm::tm_sec

	lda	#03
	jsl	_getcalr
	jsr	BCD2dec
	sta	TM + tm::tm_mday

	lda	#04
	jsl	_getcalr
	jsr	BCD2dec
	dec	a
	sta	TM + tm::tm_mon

	lda	#06
	jsl	_getcalr
	jsr	BCD2dec
	clc
	adc	#100			; offset from 1900
	sta	TM + tm::tm_year

	lda	#05
	jsl	_getcalr
	jsr	BCD2dec
	sta	TM + tm::tm_wday

	lda	#<TM
	ldx	#>TM
	jmp	_mktime

; dec = (((BCD>>4)*10) + (BCD&0xf))
BCD2dec:
	tax
	and	#%00001111
	tay
	txa
	and	#%11110000		; *16
	lsr				; *8
	sta	temp
	lsr
	lsr				; *2
	adc	temp			; = *10
	sta	temp
	tya	
	adc	temp
	rts

.endproc

;----------------------------------------------------------------------------
; TM struct with date set to 1970-01-01
.data

TM:	.word	0		; tm_sec
	.word	0		; tm_min
	.word	0		; tm_hour
	.word	1		; tm_mday
	.word	0		; tm_mon
	.word	70		; tm_year
	.word	0		; tm_wday
	.word	0		; tm_yday
	.word	0		; tm_isdst

